summaryrefslogtreecommitdiff
path: root/tests/mv/part-hardlink
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mv/part-hardlink')
-rwxr-xr-xtests/mv/part-hardlink67
1 files changed, 67 insertions, 0 deletions
diff --git a/tests/mv/part-hardlink b/tests/mv/part-hardlink
new file mode 100755
index 0000000..66cfe0d
--- /dev/null
+++ b/tests/mv/part-hardlink
@@ -0,0 +1,67 @@
+#!/bin/sh
+# Ensure that hard links are preserved when moving between partitions
+# and when the links are in separate command line arguments.
+# For additional constraints, see the comment in copy.c.
+# Before coreutils-5.2.1, this test would fail.
+
+# Copyright (C) 2004, 2005, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mv --version
+fi
+
+. $srcdir/../other-fs-tmpdir
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+if test -z "$other_partition_tmpdir"; then
+ (exit 77); exit 77
+fi
+t0="$t0 $other_partition_tmpdir"
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch f || framework_failure=1
+ln f g || framework_failure=1
+mkdir a b || framework_failure=1
+touch a/1 || framework_failure=1
+ln a/1 b/1 || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+mv f g $other_partition_tmpdir || fail=1
+mv a b $other_partition_tmpdir || fail=1
+
+cd $other_partition_tmpdir
+set `ls -Ci f g`
+test $1 = $3 || fail=1
+set `ls -Ci a/1 b/1`
+test $1 = $3 || fail=1
+
+(exit $fail); exit $fail